<script>
	export let aspectRatio
	export let width = null

	let clientWidth = null

	// This is the "real" width, being the width property if given, otherwise measured from the DOM.
	$: _width = width === null ? clientWidth : width

	let height = null
	let style = null

	$: if (_width !== null) {
		height = _width / aspectRatio
		style = [
			width !== null && `width: ${_width}px;`, //
			`height: ${height}px;`,
		]
			.filter(Boolean)
			.join("")
	}
</script>

<div bind:clientWidth {style}>
	{#if _width !== null}
		<slot width={_width} {height} />
	{/if}
</div>
